<?#-- PHP e MySQL - connessione e stampa dei risultati - riassunto ?>

<HTML>
<HEAD>
<TITLE>PHP e MySQL</TITLE>
</HEAD>

<BODY>

<H1>PHP e MySQL</H1>

<?PHP 
function fail($msg) {
  die($_SERVER['PHP_SELF'] . ": $msg<BR />" . mysql_error());
 };
?>

<?php
/* parametri per la connessione */
$dbhost="127.0.0.1";     /* server MySQL */
$dbuser="root";          /* utente       */
$dbpwd="";               /* password     */

/* connessione al server */
$conn=mysql_connect($dbhost, $dbuser, $dbpwd)
  or die("Connessione al server MySQL fallita!");
#  or fail("Connessione al server MySQL fallita!");

/* seleziona il database da usare */
$dbname="Univ";
mysql_select_db($dbname);

/* ed esegue una query ... */

/* preparazione dello statement: media dei voti degli studenti di una
   provincia data */

$prov="SP";
$query="SELECT s.Matricola, s.Nome, s.Cognome, ROUND(AVG(e.Voto)) AS Media FROM Studenti s JOIN ESAMI e ON (s.Matricola=e.Candidato) WHERE s.Provincia=\"$prov\" GROUP BY s.Matricola, s.Nome, s.Cognome";

/* Stampa la query a video ... utile per debug */
echo "<B>Query</B>: $query <BR />";

$studenti=mysql_query($query,$conn)
  or die("Query fallita" . mysql_error($conn));

$num_righe=mysql_num_rows($studenti);

/* Array enumerativo */

echo "<H3>Uso dell'array enumerativo - mysql_fetch_rows</H3>";

if (! $num_righe)
  echo "<P>Nessuno studente della provincia di $prov ha fatto esami.</P>";
else {
  echo "<P>Trovati $num_righe studenti di $prov che hanno fatto esami.<BR />\n";
  echo "Ecco le loro medie:<BR />";
  
  while ($row=mysql_fetch_row($studenti)) {
    $matricola=$row[0];
    $nome=$row[1];
    $cognome=$row[2];
    $media=$row[3];
    echo "$matricola - $nome $cognome - $media<BR />";
  };

   echo "</P>";

};

/* Array associativo */

echo "<H3>Uso dell'array associativo - mysql_fetch_assoc</H3>";

if (! $num_righe)
  echo "<P>Nessuno studente della provincia di $prov ha fatto esami.</P>";
else {
  echo "<P>Trovati $num_righe studenti di $prov che hanno fatto esami.<BR />\n";
  echo "Ecco le loro medie:<BR />";


  mysql_data_seek($studenti, 0);
  
  while ($row=mysql_fetch_assoc($studenti)) {
    $matricola=$row['Matricola'];
    $nome=$row['Nome'];
    $cognome=$row['Cognome'];
    $media=$row['Media'];
    echo "$matricola - $nome $cognome - $media<BR />";
  }
  
  echo "</P>";

};

/* Array associativo/enumerativo  */

echo "<H3>Uso dell'array enumerativo/associativo - mysql_fetch_array</H3>";

if (! $num_righe)
  echo "<P>Nessuno studente della provincia di $prov ha fatto esami.</P>";
else {
  echo "<P>Trovati $num_righe studenti di $prov che hanno fatto esami.<BR />\n";
  echo "Ecco le loro medie:<BR />";


  mysql_data_seek($studenti, 0);
  
  while ($row=mysql_fetch_array($studenti)) {
    $matricola=$row['Matricola'];
    $nome=$row[1];
    $cognome=$row['Cognome'];
    $media=$row[3];
    echo "$matricola - $nome $cognome - $media<BR />";
  }
  
  echo "</P>";
}





/* Visulizzazione come tabella  */

echo "<H3>Tabella</H3>";

/* funzione per stampare un array, come riga di tabella html */
function echo_row($row) {
  echo "<TR>";
  foreach ($row as $field) 
    echo "<TD>$field</TD>";
  echo "</TR>";
};


if (! $num_righe)
  echo "<P>Nessuno studente della provincia di $prov ha fatto esami.</P>";
else {
  echo "<P>Trovati $num_righe studenti di $prov che hanno fatto esami.<BR />\n";
  echo "Ecco le loro medie:";
  echo "</P>";

  mysql_data_seek($studenti, 0);
  
  echo "
  <TABLE border=\"1\">
  <TR> 
     <TH>Matricola</TH>
     <TH>Nome</TH>
     <TH>Cognome</TH>
     <TH>Media</TH>
   </TR>";
  
  while ($row=mysql_fetch_row($studenti))
    echo_row($row);
};

echo "</TABLE>";



/* inserimento e cancellazione di un record */


$query="INSERT INTO Docenti VALUES 
        (\"MM1\", \"Mino\",\"Monti\")";

$ins=mysql_query($query,$conn)
  or die("Inserimento fallito" . mysql_error($conn));


$query="DELETE FROM Docenti 
        WHERE CodDoc=\"MM1\"";

$del=mysql_query($query,$conn)
  or die("Cancellazione fallita" . mysql_error($conn));

?>

</BODY>
</HTML>